{ $Id: DUnit.pas,v 1.18 2000/11/12 22:01:37 juanco Exp $ }
{: DUnit: An XTreme testing framework for Delphi programs.
   @author  The DUnit Group.
   @version $Revision: 1.18 $
}
(*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is DUnit.
 *
 * The Initial Developers of the Original Code are Kent Beck, Erich Gamma,
 * and Juancarlo Aez.
 * Portions created The Initial Developers are Copyright (C) 1999-2000.
 * Portions created by The DUnit Group are Copyright (C) 2000.
 * All rights reserved.
 *
 * Contributor(s):
 * Kent Beck <kentbeck@csi.com>
 * Erich Gamma <Erich_Gamma@oti.com>
 * Juanco Aez <juanco@users.sourceforge.net>
 * Chris Morris <chrismo@users.sourceforge.net>
 * Jeff Moore <JeffMoore@users.sourceforge.net>
 * Kenneth Semeijn <dunit@designtime.demon.nl>
 * The DUnit group at SourceForge <http://dunit.sourceforge.net>
 *
 *)
{The contents of this unit are entirely deprecated;  They are included as a
temporary measure for limited backward compatibility.  Please convert to using the
equivelent functionality in the TestFramework unit.}
unit DUnit;

interface

uses
  TestFramework;

const
  rcs_id :string = '@(#)$Id: DUnit.pas,v 1.18 2000/11/12 22:01:37 juanco Exp $';

type
  ITestSuite = TestFramework.ITestSuite;

  TTestSuite = TestFramework.TTestSuite;

  TTestCase = TestFramework.TTestCase;

{: Create a test suite out of the test methods in a TTestCase descendant }
function  testSuiteOf(aclass: TTestCaseClass): ITestSuite;                                overload;
{: Create a named test suite out a series of tests }
function  MakeTestSuite(name :string; const tests :array of ITest): ITestSuite;             overload;
{: Create a test suite hierarchy out of a series of TTestCase descendants }
function  MakeTestSuites(name :string; const classes :array of TTestCaseClass): ITestSuite;  overload;

procedure RegisterTest(path: string; test: ITest); overload;
procedure RegisterTest(test: ITest);               overload;

procedure RegisterTests(path :string; const tests :array of ITest);
procedure RegisterTestSuites(path :string; const classes :array of TTestCaseClass);

function RunTest(suite :ITest; listeners :array of ITestListener) :TTestResult; overload;
function RunTest(aclass :TTestCaseClass; listeners :array of ITestListener) :TTestResult; overload;
function RunRegisteredTests(listeners :array of ITestListener) :TTestResult;

implementation

uses
  SysUtils;

{ Convenience routines }

function  testSuiteOf(aclass: TTestCaseClass): ITestSuite;
begin
  result := TestFramework.testSuiteOf(aclass)
end;

function  MakeTestSuite(name :string; const tests :array of ITest): ITestSuite;             overload;
begin
  Result := TestFramework.MakeTestSuite(name, tests)
end;

function  MakeTestSuites(name :string; const classes :array of TTestCaseClass): ITestSuite;  overload;
begin
  Result := TestFramework.MakeTestSuites(name, classes)
end;

procedure RegisterTest(path: string; test: ITest);
begin
  TestFramework.RegisterTest(path, test);
end;

procedure RegisterTests(path :string; const tests :array of ITest);
begin
  TestFramework.RegisterTests(path, tests)
end;

procedure RegisterTestSuites(path :string; const classes :array of TTestCaseClass); overload;
begin
  TestFramework.RegisterTestSuites(path, classes)
end;

procedure RegisterTest(test: ITest);
begin
  TestFramework.RegisterTest('', test);
end;

function RegisteredTests: ITestSuite;
begin
  Result := TestFramework.RegisteredTests;
end;

function RunTest(suite :ITest; listeners :array of ITestListener) :TTestResult;
begin
   Result := TestFramework.RunTest(suite, listeners);
end;

function RunTest(aclass :TTestCaseClass; listeners :array of ITestListener) :TTestResult; overload;
begin
   Result := TestFramework.RunTest(aclass, listeners);
end;

function RunRegisteredTests(listeners :array of ITestListener) :TTestResult;
begin
   Result := TestFramework.RunRegisteredTests(listeners);
end;

end.
